<?php

namespace Dalten\RuianToUir\Converter;

use Dalten\RuianToUir\Converter\Exception\InvalidRuianDataException;
use Dalten\RuianToUir\Converter\Field\PointCoordinatesConverter;
use Dalten\RuianToUir\Converter\Result\AddRecord;
use Dalten\RuianToUir\Converter\Result\ResultInterface;

/**
 * Převaděč na entitu kraje.
 */
class County extends AbstractConverter implements ConverterInterface
{
    /**
     * Nastavuje konfiguraci třídy.
     *
     * @param PointCoordinatesConverter $coordinateConverter
     */
    public function __construct(PointCoordinatesConverter $coordinateConverter)
    {
        parent::__construct($coordinateConverter);
        $this->handledTag = 'vf:Vusc';
    }

    /**
     * {@inheritdoc}
     */
    public function convert(\XMLReader $document): ResultInterface
    {
        $element = $this->getNextElement($document);

        if ($element instanceof \XMLReader && $element->name === $this->handledTag) {
            // pokud jsme narazili na tag mčásti, který obsahuje další mčást, zpracujeme tu a tuhle přeskočíme
            $this->getNextElement($document);
        }
        $data = ['stav' => 1];
        do {
            switch ($document->name) {
                case 'vci:Kod':
                    $data['kraj_kod'] = (int) $document->readString();

                    break;
                case 'vci:Nazev':
                    $data['zkratka'] = $data['nazev'] = (string) $document->readString();

                    break;
                case 'vci:NutsLau':
                    $data['nuts3'] = (string) $document->readString();

                    break;
                case 'vci:Geometrie':
                    if (!$document->isEmptyElement) {
                        $data['geom'] = $this->getGeometryData($document);
                    }

                    break;
                default:
                    $this->skipToElementEnd($document);

                    break;
            }
        } while ($this->getNextElement($document));

        if (empty($data['kraj_kod'])) {
            throw InvalidRuianDataException::becauseRequiredAttributeIsMissing($this->getName(), 'vci:Kod');
        }

        return new AddRecord($this->getName(), $data['kraj_kod'], $data);
    }
}
